﻿package org.cristalab.net
{
	import flash.display.MovieClip;
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.StatusEvent;
	import flash.net.LocalConnection;
	//-------------------------------------------------------------------------------- 
	public class SWFConnection extends EventDispatcher
	{
		public static const SEND_SUCCESS:String = "onSendSuccess";
		public static const SEND_FAIL:String = "onSendFail";
		public static const CONNECT_SUCCESS:String = "onConnectSuccess";
		public static const CONNECT_FAIL:String = "onConnectFail";
		private var _connectionSend:LocalConnection;
		private var _connectionListen:LocalConnection;
		//---------------------------------------------------------------------------- 
		public function SWFConnection(main:MovieClip, name:String) 
		{
			_connectionSend = new LocalConnection();
			_connectionSend.addEventListener(StatusEvent.STATUS, onStatus);
			
			_connectionListen = new LocalConnection();
			_connectionListen.client = main;
			
			try
			{
                _connectionListen.connect(name);
				dispatchEvent(new Event(SWFConnection.CONNECT_SUCCESS));
            }
			catch (error:ArgumentError)
			{
                trace(error);
				dispatchEvent(new Event(SWFConnection.CONNECT_FAIL));
            }			
		} 
		//---------------------------------------------------------------------------- 
		public function send(name:String, funcion:String, params:Array = null):void
		{
			_connectionSend.send(name, funcion, params);
		}
		//---------------------------------------------------------------------------- 
		private function onStatus(e:StatusEvent):void
		{
			switch (e.level)
			{
				case "status" :
					dispatchEvent(new Event(SWFConnection.SEND_SUCCESS));
					break;
				case "error" :
					dispatchEvent(new Event(SWFConnection.SEND_FAIL));
					break;
			}
		}
		//---------------------------------------------------------------------------- 
	} 
}